package com.gic.store.service.impl;

import com.gic.commons.util.GlobalInfo;
import com.gic.store.dao.mapper.TabStorePhotoMapper;
import com.gic.store.dto.StorePhotoDTO;
import com.gic.store.entity.TabStorePhoto;
import com.gic.store.service.StorePhotoService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * @author zhiwj
 * @date 2019/6/27
 */
@Service
public class StorePhotoServiceImpl implements StorePhotoService {

    @Autowired
    private TabStorePhotoMapper tabStorePhotoMapper;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void editStoreImage(Integer enterpriseId, Integer storeId, List<StorePhotoDTO> photoList, List<Integer> delPhotos) {
        if (CollectionUtils.isNotEmpty(delPhotos)) {
            for (Integer delId : delPhotos) {
                TabStorePhoto storePhoto = new TabStorePhoto();
                storePhoto.setStorePhotoId(delId);
                storePhoto.setStatus(GlobalInfo.DATA_STATUS_DELETE);
                tabStorePhotoMapper.updateByPrimaryKeySelective(storePhoto);
            }
        }
        if (CollectionUtils.isNotEmpty(photoList)) {
            for (StorePhotoDTO storePhotoDTO : photoList) {
                TabStorePhoto storePhoto = new TabStorePhoto();
                storePhoto.setStorePhotoId(storePhotoDTO.getStorePhotoId());
                storePhoto.setEnterpriseId(enterpriseId);
                storePhoto.setImageCode(storePhotoDTO.getImageCode());
                storePhoto.setImageUrl(storePhotoDTO.getImageUrl());
                storePhoto.setSort(storePhotoDTO.getSort());
                storePhoto.setStatus(GlobalInfo.DATA_STATUS_NORMAL);
                storePhoto.setStoreId(storeId);
                if (storePhotoDTO.getStorePhotoId() == null) {
                    storePhoto.setCreateTime(new Date());
                    tabStorePhotoMapper.insertSelective(storePhoto);
                } else {
                    tabStorePhotoMapper.updateByPrimaryKeySelective(storePhoto);
                }
            }
        }
    }

    @Override
    public List<TabStorePhoto> listStorePhoto(Integer enterpriseId, Integer storeId) {
        return tabStorePhotoMapper.listStorePhoto(enterpriseId, storeId);
    }
}